routes/web.php
<?php

use App\Http\Controllers\LanguageSwitcherController;
use App\Http\Controllers\WordController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('language')->group(function (){
    Route::get('/', [WordController::class, 'index'])->name('home');
    Route::resource('words', WordController::class);
    Auth::routes();
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index']);
    Route::post('translate/{word}', [WordController::class, 'translate'])->name('words.translate');
    Route::get('translation/{word}', [WordController::class, 'translation'])->name('words.translation');
});

Route::get('language/{locale}', [LanguageSwitcherController::class, 'switcher'])
    ->name('language.switcher')->where('locale', 'en|ru');

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];


    /**
     * @return HasMany
     */
    public function words(): HasMany
    {
        return $this->hasMany(Word::class);
    }
}

app/Models/Word.php
<?php

namespace App\Models;

use Astrotomic\Translatable\Contracts\Translatable as TranslatableContract;
use Astrotomic\Translatable\Translatable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

/**
 * @method static create(array $data)
 */
class Word extends Model implements TranslatableContract
{
    use HasFactory;
    use Translatable;

    protected $fillable = ['user_id'];
    public $translatedAttributes = ['title'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}

app/Models/WordTranslation.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class WordTranslation extends Model
{
    public $timestamps = false;
    protected $fillable = ['title'];

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/LanguageSwitcherController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class LanguageSwitcherController extends Controller
{
    /**
     * @param Request $request
     * @param string $locale
     * @return RedirectResponse
     */
    public function switcher(Request $request, string $locale): RedirectResponse
    {
        $request->session()->put('locale', $locale);
        return back();
    }
}

app/Http/Controllers/WordController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\WordRequest;
use App\Models\Word;
use App\Models\WordTranslation;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class WordController extends Controller
{
    /**
     * @return Factory|View|Application
     */
    public function index()
    {
        $words = WordTranslation::all()->where('locale', 'ru');
        return view('words.index', compact('words'));
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param WordRequest $request
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function store(WordRequest $request): RedirectResponse
    {
        $this->authorize('create', Word::class);
        $data = ['user_id' => Auth::id(),
            'ru' => ['title' => $request->input('title')],
        ];

        $translate = Word::create($data);
        $translate->save();
        return redirect()->route('words.index');
    }


    /**
     * @param Word $word
     * @return Application|Factory|View
     */
    public function show(Word $word)
    {
        return view('words.show', compact('word'));
    }


    /**
     * @param Request $request
     * @param Word $word
     */
    public function translate(Request $request, Word $word)
    {
        $this->authorize('update', $word);
        $data = ['user_id' => Auth::id(),
            'en' => ['title' => $request->input('entitle')],
            'fr' => ['title' => $request->input('frtitle')],
            'kg' => ['title' => $request->input('kgtitle')],
            'kz' => ['title' => $request->input('kztitle')],
        ];

        $word->update($data);
        return redirect()->route('words.index');
    }

    /**
     * @return Application|Factory|View
     */
    public function translation(Word $word)
    {
        return view('words.translation', compact('word'));
    }

}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    @lang('messages.main')
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}"> @lang('messages.login')</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}"> @lang('messages.register')</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest

                        <select class="custom-select" onchange="location = this.value;">
                            <option @if (session('locale') == 'en') selected @endif value="{{route('language.switcher', 'en')}}">
                                EN
                            </option>
                            <option @if (session('locale') == 'ru') selected @endif value="{{route('language.switcher', 'ru')}}">
                                RU
                            </option>
                        </select>
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            <div class="container">
                @yield('content')
            </div>
        </main>
    </div>
</body>
</html>

resources/views/words/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">№</th>
                    <th scope="col">@lang('messages.words')</th>
                </tr>
                </thead>
                <tbody>
                @foreach($words as $word)
                <tr>
                    <th scope="row">{{$loop->iteration}}</th>
                    <td>
                        <a href="{{route('words.translation', ['word'=>$word])}}">
                            {{$word->title}}
                        </a>
                    </td>
                </tr>
                @endforeach
                </tbody>
            </table>
        </div>
        @can('create', \App\Models\Word::class)
        <div class="col">
            <form action="{{route('words.store')}}" method="post">
                @csrf
                <input id="title" type="text" class="form-control @error('title') is-invalid @enderror" name="title" value="{{ old('title') }}" required autocomplete="title" autofocus>

                @error('title')
                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                @enderror <br>

                <button class="btn btn-sm btn-outline-success">@lang('messages.added')</button>
            </form>
        </div>
        @endcan
    </div>
@endsection

resources/views/words/show.blade.php
@extends('layouts.app')

@section('content')

    <form action="{{route('words.translate', compact('word'))}}" method="post">
        @csrf
        <div class="form-group row">

            <div class="col-md-8">
                <label for="title">EN</label>
                <input class="form-control @error('title') is-invalid @enderror" type="text"
                       id="title" name="entitle"
                       value="{{$word->translate('en')->title ?? ''}}"/>
                @error('title')
                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                @enderror
            </div>

            <div class="col-md-8">
                <label for="title">FR</label>
                <input class="form-control @error('title') is-invalid @enderror" type="text"
                       id="title" name="frtitle"
                       value="{{$word->translate('fr')->title ?? ''}}"/>
                @error('title')
                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                @enderror
            </div>

            <div class="col-md-8">
                <label for="title">KG</label>
                <input class="form-control @error('title') is-invalid @enderror" type="text"
                       id="title" name="kgtitle"
                       value="{{$word->translate('kg')->title ?? ''}}"/>
                @error('title')
                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                @enderror
            </div>

            <div class="col-md-8">
                <label for="title">KZ</label>
                <input class="form-control @error('title') is-invalid @enderror" type="text"
                       id="title" name="kztitle"
                       value="{{$word->translate('kz')->title ?? ''}}"/>
                @error('title')
                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                @enderror
            </div>
        </div>
        <button class="btn btn-sm btn-outline-success">@lang('messages.added')</button>
    </form>


@endsection

resources/views/words/translation.blade.php
@extends('layouts.app')

@section('content')

    <div class="row">
        <div class="col">
            <h2 class="text-center">{{$word->title}}</h2><br>
            <h3>EN: {{$word->translate('en')->title ?? ''}}</h3>
            <h3>FR: {{$word->translate('fr')->title ?? ''}}</h3>
            <h3>KG: {{$word->translate('kg')->title ?? ''}}</h3>
            <h3>KZ: {{$word->translate('kz')->title ?? ''}}</h3>
            <br>
            @can('update', $word)
            <a href="{{route('words.show', compact('word'))}}">
               <b>@lang('messages.add')</b>
            </a>
            @endcan
        </div>
    </div>
@endsection